#!/usr/bin/perl -w

@palettedata = (
((0,0,0,0),(0,0,128,0),(0,128,0,0),(0,128,128,0),(128,0,0,0),(128,0,128,0) 
,(128,64,0,0),(128,128,128,0),(64,64,64,0),(0,0,255,0),(0,255,0,0) 
,(0,255,255,0),(255,0,0,0),(255,0,255,0),(255,255,0,0),(255,255,255,0)),
((0,0,0,0),(0,0,255,0),(0,255,0,0),(0,255,255,0),(255,0,0,0),(255,0,255,0) 
,(255,128,0,0),(196,196,196,0),(128,128,128,0),(128,128,255,0),(128,255,128,0) 
,(128,255,255,0),(255,128,128,0),(255,128,255,0),(255,255,128,0),(255,255,255,0)),
((0,0,0,0),(0,128,0,0),(128,0,0,0),(128,64,0,0),(0,0,128,0),(0,128,128,0) 
,(128,0,128,0),(128,128,128,0),(64,64,64,0),(0,255,0,0),(255,0,0,0) 
,(255,255,0,0),(0,0,255,0),(0,255,255,0),(255,0,255,0),(255,255,255,0)),
((0,0,0,0),(0,255,0,0),(255,0,0,0),(255,128,0,0),(0,0,255,0),(0,255,255,0) 
,(255,0,255,0),(196,196,196,0),(128,128,128,0),(128,255,128,0),(255,128,128,0) 
,(255,255,128,0),(128,128,255,0),(128,255,255,0),(255,128,255,0),(255,255,255,0)));

while ( $l = <> )
{
	chomp $l ;

	if ( 1 == (( $filename ) = ( $l =~ /^Uint3 (.+)\[\]=.*$/ )))
	{
		if ( $filename =~ /near.*vgatable/ )
		{
			# done
			exit 0 ;
		}
		open XPM , ">xpm/" . $filename . ".xpm"
			or die "Opening " . $filename . " failed\n" ;

		print XPM "/* XPM */\n" ;
		print XPM "static char * " . $filename . "_xpm[] = {\n" ;

		@pixels = ( ) ;
		do {
			$l = <> ;
			chomp $l ;

			$ol = $l ;
			$l =~ s/(};|,)$// ;
			@records = split ( ',' , $l ) ;
			$width = 0 + @records ;

			$pixels[ @pixels ] = $l ;
		} while ( ! ( $ol =~ /};/ )) ;
		$height = @pixels ;

		print XPM "\"$width $height 65 1\",\n" ;
		print XPM '"0  s background    c None",' . "\n" ;
		for ( $i = 0 ; $i < 64 ; $i ++ )
		{
			$n = $i * 4 ;
			$r = $palettedata[ $n + 0 ] ;
			$g = $palettedata[ $n + 1 ] ;
			$b = $palettedata[ $n + 2 ] ;
			
			printf XPM '"%c  c #%02x%02x%02x",' . "\n" ,
				( $i + ord '1' ) , $r , $g , $b ;
		}
		for ( $i = 0 ; $i < @pixels ; $i ++ )
		{
			print XPM '"' ;
			@records = split ( ',' , $pixels[ $i ] ) ;
			foreach $r ( @records )
			{
				( $p ) = $r =~ /^ *(0x[0-9a-f][0-9a-f]) *$/ ;
				if (( ! defined $p )
				|| ( 0 == length $p ))
				{
					die "failed at line " . $pixels[ $i ] . "\n";
				}
				$p = hex $p ;
				if ( $p > 63 )
				{
					print XPM '0' ;
				} else {
					printf XPM "%c" , ( $p + ord '1' ) ;
				}
			}
			if ( $i < ( @pixels - 1 ))
			{
				print XPM '",' . "\n" ;
			} else {
				printf XPM '"%c;' . "\n" , 0x7d ;
			}
		}
		close XPM ;
	}
}

